package com.javaseleniumtemplate.pages.semLote;
import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class EntradaDeEstoqueSemLotePage extends PageBase {

        //Evento de loading da pagina:
        By loadingWait = By.xpath("//*[@class='zh-loading-desc ng-binding']");
        //BUSCA DO PRODUTO ATRAVES DO FLOAT-CONTROL:

        By campoProcurarFloatControl = By.xpath("//*[@id='popup']//*[@placeholder='Procurar']");

        //FILTRO INICIAL:
        By clearFilter = By.xpath("//*[@data-zh-id='681099116922975830150_filter_action_clear']");
        By IconeUnidade = By.xpath("//*[@data-zh-id='6810991164021547667197']//*[@id='NMFILIAL']/span[1]");
        By SelecioanarUnidadeAjusteIventario = By.xpath("//*[@data-zh-field-name='NMFILIAL']//*[.='HELA Nao Controla Lote']");
        By btnIconAlmoxarifado1 = By.xpath("//*[@data-zh-id='68109911634602156202']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
        By almoxarifado = By.xpath("//*[@id='grid-9000']//*[.='HELA MATRIZ']");//Nao precisa de data-zh-id
        By btnXlimparDataEntradaEstFiltro = By.xpath("//*[@data-zh-id='6810991163743328191960']//*[@zh-icon='no-border close-x']");
        By IconeData = By.xpath("//*[@data-zh-id='6810991163743328191960']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
        By DataEscolhidaInicial = By.xpath("//*[@id='zh-calendar-Calendar']//*[.='1']");
        By BtnOkFiltro = By.xpath("//*[@id='footer']/div[3]/ul/li/a/span");
        By aplicarFiltro = By.xpath("//*[@data-zh-id='681099116922975830150_filter_action_never']//span[text() = 'Aplicar filtro']"); //data-zh-id esta vazio

        //ADICIONAR ENTRADA DE ESTOQUE:
        By btnAdicionar = By.xpath("//*[@id='footer']//*[@data-zh-id='6810991163208020097228']");
        By btnXlimparDataEntrada = By.xpath("//*[@data-zh-id='68109911641263904779']//*[@zh-icon='no-border close-x']");
        By IconeData2 = By.xpath("//*[@data-zh-id='68109911641263904779']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
        By DataEntrada = By.xpath("//*[@id='zh-calendar-Widget']//*[@class='day today']");
        By campoDescricao = By.xpath("//*[@zh-id='681099116909717241781']");
        By btnAdicionar2 = By.xpath("//*[@id='footer']//*[@data-zh-id='6810991163334385738170']");
        By btnIconProduto = By.xpath("//*[@data-zh-id='6810991164266606876154']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
        By produto = By.xpath("//span[text()='SUMO DE LIMAO - CX12 500ML']");

        //Informações Complementares do Produto
        By btnIconLimparAlmoxarifado = By.xpath("//*[@data-zh-id='764527517256954914288']//*[@class='zh-icon zh-icon-close-x zh-icon-no-border']");
        By btnIconProcurarAlmoxarifado = By.xpath("//*[@data-zh-id='764527517256954914288']//*[@class='zh-icon zh-icon-search zh-icon-no-border']");
        By campoLote = By.xpath("//*[@data-zh-id='7645275171631791325304']//input");

        By btnCalendario2 = By.xpath("//*[@data-zh-id='76452751786488369316']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
        By DataEscolhidaAtual = By.xpath("//*[@class='day today']");//Nao precisa de data-zh-id
        By confirmar = By.xpath("//*[@data-zh-id='7645275174220205724322']//*[.='Confirmar']");
        By caixaDeDialogo = By.xpath("//span[text()='Sim']");

        //sub-aba Produtos:
        By campoQuantidade = By.xpath("//*[@zh-id='6810991161502326140163']");
        By campoValorUnitario = By.xpath("//*[@zh-id='6810991162722361895168']");

        //salvar Item:
        By salvarItem = By.xpath("//*[@data-zh-id='6810991163713795285178']");

        //salvar Item:
        By salvarLancamento = By.xpath("//*[@data-zh-id='6810991163466019639828']");


    //Editar
    By Btnlancamento = By.xpath("//span[text()='Teste Automatizado']");
    By produto2 = By.xpath("//span[text()='Hela Poultry Broth Paste Clear KG']");
    By confirmar2 = By.xpath("//span[text()='Confirmar']");

    By campoDescricao2 = By.xpath("//*[@zh-id='681099116909717241781']");
    By salvarItem2 = By.xpath("//span[text()='Salvar Item']");




    //Deletar

    By btnSim = By.xpath("//span[text()='Sim']");
    By Btnlancamento2 = By.xpath("//span[text()='Deletar']");
    By excluir = By.xpath("//*[@data-zh-id='681099116401786073830']");



    //Banco

    By numerolancado = By.cssSelector(".row-editing > .td:nth-child(1) > span");
    By voltar = By.xpath("//span[text()='Voltar']");

    public void preencherFiltroEntradaDeEstoque(String descUnidade,String descAlmoxarifado){

        //FILTRO INICIAL:
        waitForVisibilityOfElementLocated(clearFilter);
        click(clearFilter);
        waitForInvisibilityOfElementLocated(loadingWait);
        //UNIDADE:
        waitForVisibilityOfElementLocated(IconeUnidade);
        click(IconeUnidade);
        waitForInvisibilityOfElementLocated(loadingWait);
                //inicio busca no float-control
                waitForVisibilityOfElementLocated(campoProcurarFloatControl);
                click(campoProcurarFloatControl);
                sendKeys(campoProcurarFloatControl,descUnidade);
                waitForInvisibilityOfElementLocated(loadingWait);
                //fim busca no float-control
        waitForVisibilityOfElementLocated(SelecioanarUnidadeAjusteIventario);
        click(SelecioanarUnidadeAjusteIventario);
        waitForInvisibilityOfElementLocated(loadingWait);

        //ALMOXARIFADO:
        waitForVisibilityOfElementLocated(btnIconAlmoxarifado1);
        click(btnIconAlmoxarifado1);
        waitForInvisibilityOfElementLocated(loadingWait);
        //inicio busca no float-control
            waitForVisibilityOfElementLocated(campoProcurarFloatControl);
            click(campoProcurarFloatControl);
            sendKeys(campoProcurarFloatControl,descAlmoxarifado);
            waitForInvisibilityOfElementLocated(loadingWait);
            waitForVisibilityOfElementLocated(almoxarifado);
            click(almoxarifado);
            waitForInvisibilityOfElementLocated(loadingWait);
        //fim  busca no float-control

        //DATA:
        waitForVisibilityOfElementLocated(btnXlimparDataEntradaEstFiltro);
        click(btnXlimparDataEntradaEstFiltro);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(IconeData);
        click(IconeData);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(DataEscolhidaInicial);
        click(DataEscolhidaInicial); //Data final aparece automaticamente.
        waitForVisibilityOfElementLocated(BtnOkFiltro);
        click(BtnOkFiltro); //data-zh-id esta vazio
        waitForInvisibilityOfElementLocated(loadingWait);
        //APLICAR FILTRO
        waitForVisibilityOfElementLocated(aplicarFiltro);
        click(aplicarFiltro);
        waitForInvisibilityOfElementLocated(loadingWait);
   }
    public void adicionarEntradadaDeEstoque(String cmpDesc,String descProduto,String quantidade,String descAlmoxarifado,String DescCampoLote,String valorUnitario){

        //Adicionar
        waitForVisibilityOfElementLocated(btnAdicionar);
        click(btnAdicionar);
        waitForInvisibilityOfElementLocated(loadingWait);

        //SUB-ABA ENTRADA DE ESTOQUE:

        //Data Entrada:
        waitForVisibilityOfElementLocated(btnXlimparDataEntrada);
        click(btnXlimparDataEntrada);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(IconeData2);
        click(IconeData2);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(DataEntrada);
        click(DataEntrada);
        waitForInvisibilityOfElementLocated(loadingWait);
        //Descrição:
        waitForVisibilityOfElementLocated(campoDescricao);
        click(campoDescricao);
        sendKeys(campoDescricao, cmpDesc);
        waitForInvisibilityOfElementLocated(loadingWait);
        //Adicionar:
        waitForVisibilityOfElementLocated(btnAdicionar2);
        click(btnAdicionar2);
        waitForInvisibilityOfElementLocated(loadingWait);
        //Produto:
        waitForVisibilityOfElementLocated(btnIconProduto);
        click(btnIconProduto);
        waitForInvisibilityOfElementLocated(loadingWait);
        //inicio busca no float-control
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl, descProduto);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(produto);
        click(produto);
        waitForInvisibilityOfElementLocated(loadingWait);
        //fim  busca no float-control

        //Campo Informações Complementares do Produto:
        waitForVisibilityOfElementLocated(btnIconLimparAlmoxarifado);
        click(btnIconLimparAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(btnIconProcurarAlmoxarifado);
        click(btnIconProcurarAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);

        //inicio busca no float-control
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl, descAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(almoxarifado);
        click(almoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
        //fim  busca no float-control
        //lote:
       // waitForVisibilityOfElementLocated(campoLote);
       // click(campoLote);
        //sendKeys(campoLote, DescCampoLote);


        waitForVisibilityOfElementLocated(btnCalendario2);
        click(btnCalendario2);
        waitForVisibilityOfElementLocated(DataEscolhidaAtual);
        click(DataEscolhidaAtual);
        waitForInvisibilityOfElementLocated(loadingWait);

        //btn confirmar:
        waitForVisibilityOfElementLocated(confirmar);
        click(confirmar);
        waitForInvisibilityOfElementLocated(loadingWait);

        //sub-aba Produtos:

        //Caixa de dialogo
        waitForVisibilityOfElementLocated(caixaDeDialogo);
        click(caixaDeDialogo);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Quantidade:
        waitForVisibilityOfElementLocated(campoQuantidade);
        sendKeys(campoQuantidade, quantidade);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Valor Unitario:
        waitForVisibilityOfElementLocated(campoValorUnitario);
        clear(campoValorUnitario);
        sendKeys(campoValorUnitario, valorUnitario);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Salvar Item:
        waitForVisibilityOfElementLocated(salvarItem);
        click(salvarItem);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Salvar Lançamento:
        waitForVisibilityOfElementLocated(salvarLancamento);
        click(salvarLancamento);
        waitForInvisibilityOfElementLocated(loadingWait);


        //Banco Captura

        waitForVisibilityOfElementLocated(numerolancado);
        waitForVisibilityOfElementLocated(voltar);
        click(voltar);




    }

    //Banco tela de entrada
    public String retornaNumeroLacamento(){
        return  getText(numerolancado);
    }



    public void EditarEntradaEstoque(String cmpDesc2, String cmpProduto,String quantidadeEditado, String valorEditado){
        //APLICAR FILTRO
        waitForVisibilityOfElementLocated(aplicarFiltro);
        click(aplicarFiltro);
        waitForInvisibilityOfElementLocated(loadingWait);


        //Editar
        waitForVisibilityOfElementLocated(Btnlancamento);
        click(Btnlancamento);

        //Campo descrição
        waitForVisibilityOfElementLocated(campoDescricao2);
        click(campoDescricao2);
        clear(campoDescricao2);
        sendKeys(campoDescricao2, cmpDesc2);
        waitForInvisibilityOfElementLocated(loadingWait);



        //Clicar em editar
        waitForVisibilityOfElementLocated(btnAdicionar2);
        click(btnAdicionar2);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Clicar em produto
        waitForVisibilityOfElementLocated(btnIconProduto);
        click(btnIconProduto);
        waitForInvisibilityOfElementLocated(loadingWait);

        //start Float Control
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,cmpProduto );
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(produto2);
        click(produto2);
        waitForInvisibilityOfElementLocated(loadingWait);
        //End Search float control

        //Confirmar
        waitForVisibilityOfElementLocated(confirmar2);
        click(confirmar2);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Caixa de dialogo
        waitForVisibilityOfElementLocated(btnSim);
        click(btnSim);
        waitForInvisibilityOfElementLocated(btnSim);


        //Quantidade:
        waitForVisibilityOfElementLocated(campoQuantidade);
        clear(campoQuantidade);
        sendKeys(campoQuantidade, quantidadeEditado);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Valor Unitario:
        waitForVisibilityOfElementLocated(campoValorUnitario);
        clear(campoValorUnitario);
        sendKeys(campoValorUnitario,valorEditado);
        waitForInvisibilityOfElementLocated(loadingWait);


        //Salvar Item:
        waitForVisibilityOfElementLocated(salvarItem2);
        click(salvarItem2);
        waitForInvisibilityOfElementLocated(loadingWait);

        //Salvar Lançamento:
        waitForVisibilityOfElementLocated(salvarLancamento);
        click(salvarLancamento);
        waitForInvisibilityOfElementLocated(loadingWait);


    }

        //Excluir
         public void ExcluirEntradaDeEstoque(){

        //APLICAR FILTRO
        waitForVisibilityOfElementLocated(aplicarFiltro);
        click(aplicarFiltro);
        waitForInvisibilityOfElementLocated(loadingWait);


        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(Btnlancamento2);
        click(Btnlancamento2);
        waitForInvisibilityOfElementLocated(loadingWait);

       waitForVisibilityOfElementLocated(excluir);
       click(excluir);

       waitForInvisibilityOfElementLocated(loadingWait);



        //opção
        waitForVisibilityOfElementLocated(btnSim);
        click(btnSim);
        waitForInvisibilityOfElementLocated(loadingWait);


    }
}
